<?xml version="1.0"?>
<!-- 
(c)2005 David Sporn

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public
License version 2.1 as published by the Free Software Foundation.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text"/>

<!-- Main part -->
<xsl:template match="RequestProcessor"><![CDATA[<?php 
//
// DO NOT EDIT ! THIS CODE WAS AUTOMATICALLY GENERATED !
//

require_once("lib/RequestParserBase.php") ;

/**]]><xsl:value-of select="@classname"/><![CDATA[.
 *
]]><xsl:value-of select="description"/><![CDATA[
 *
 * This request processor allow access to the following values :
 * (Name, type, default value)]]>
<xsl:apply-templates mode="varDocumentation" select="property"/><![CDATA[ */
class ]]><xsl:value-of select="@classname"/><![CDATA[ extends RequestParserBase
{
	//Name of request variables
]]><xsl:apply-templates mode="varDeclaration" select="property"/><![CDATA[
	//Constructor
	function ]]><xsl:value-of select="@classname"/><![CDATA[($nameSpace = '')
	{
]]><xsl:apply-templates mode="varInitialisation" select="property"/><![CDATA[
	}
	
	//Accessors	
]]><xsl:apply-templates mode="getter" select="property"/><![CDATA[
}
?>]]>
</xsl:template>


<!-- Property documentation -->
<xsl:template match="property" mode="varDocumentation"><![CDATA[ *  ]]><xsl:value-of select="@name"/><![CDATA[, ]]><xsl:value-of select="@type"/><![CDATA[, ']]><xsl:value-of select="@defaultValue"/><![CDATA['
]]></xsl:template>

<!-- Property declaration -->
<xsl:template match="property" mode="varDeclaration"><![CDATA[	var $my]]><xsl:value-of select="@name"/><![CDATA[ ;
]]></xsl:template>

<!-- Property initialisation -->
<xsl:template match="property" mode="varInitialisation"><![CDATA[		$this->my]]><xsl:value-of select="@name"/><![CDATA[ = $nameSpace.']]><xsl:value-of select="@name"/><![CDATA[' ;
]]></xsl:template>

<!-- Property accessors (default, then specific type value) -->
<xsl:template match="property" mode="getter"><![CDATA[/**]]><xsl:value-of select="description"/><![CDATA[
	 * @param default default value.
	 * @return a string
	 */
	function get]]><xsl:value-of select="@name"/><![CDATA[($default = ']]><xsl:value-of select="@defaultValue"/><![CDATA[')
	{
		return $this->getSingleLineValue($this->my]]><xsl:value-of select="@name"/><![CDATA[, $default );
	}
]]></xsl:template>

<xsl:template match="property[@type='SingleLineString']" mode="getter"><![CDATA[/**]]><xsl:value-of select="description"/><![CDATA[
	 * @param default default value.
	 * @return a string (single line)
	 */
	function get]]><xsl:value-of select="@name"/><![CDATA[($default = ']]><xsl:value-of select="@defaultValue"/><![CDATA[')
	{
		return $this->getSingleLineValue($this->my]]><xsl:value-of select="@name"/><![CDATA[, $default );
	}
]]></xsl:template>

<xsl:template match="property[@type='integer']" mode="getter"><![CDATA[/**]]><xsl:value-of select="description"/><![CDATA[
	 * @param default default value.
	 * @return an integer
	 */
	function get]]><xsl:value-of select="@name"/><![CDATA[($default = ']]><xsl:value-of select="@defaultValue"/><![CDATA[')
	{
		return $this->getIntegerValue($this->my]]><xsl:value-of select="@name"/><![CDATA[, $default );
	}
]]></xsl:template>

<xsl:template match="property[@type='string']" mode="getter"><![CDATA[/**]]><xsl:value-of select="description"/><![CDATA[
	 * @param default default value.
	 * @return a string
	 */
	function get]]><xsl:value-of select="@name"/><![CDATA[($default = ']]><xsl:value-of select="@defaultValue"/><![CDATA[')
	{
		return $this->getStringValue($this->my]]><xsl:value-of select="@name"/><![CDATA[, $default );
	}
]]></xsl:template>

</xsl:stylesheet>